Index: src/uk/me/parabola/imgfmt/app/net/RouteCenter.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/RouteCenter.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/RouteCenter.java	(working copy)
@@ -124,7 +124,7 @@
 
 			writer.position(pos);
 			log.debug("rewrite taba offset", writer.position(), bo);
-			writer.put(bo);
+			writer.put1u(bo);
 
 			// fill in arc pointers
 			node.writeSecond(writer);
@@ -133,11 +133,11 @@
 		writer.position(tablesOffset);
 
 		// Write the tables header
-		writer.put(tabC.getFormat());
-		writer.put3(centralPoint.getLongitude());
-		writer.put3(centralPoint.getLatitude());
-		writer.put(tabA.getNumberOfItems());
-		writer.put(tabB.getNumberOfItems());
+		writer.put1u(tabC.getFormat());
+		writer.put3s(centralPoint.getLongitude());
+		writer.put3s(centralPoint.getLatitude());
+		writer.put1u(tabA.getNumberOfItems());
+		writer.put1u(tabB.getNumberOfItems());
 
 		tabA.write(writer);
 		tabB.write(writer);
Index: src/uk/me/parabola/imgfmt/app/net/RouteNode.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/RouteNode.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/RouteNode.java	(working copy)
@@ -61,8 +61,8 @@
 	private int flags;
 
 	private final CoordNode coord;
-	private char latOff;
-	private char lonOff;
+	private int latOff;
+	private int lonOff;
 	private List<RouteArc[]> throughRoutes;
 
 	// contains the maximum of roads this node is on, written with the flags
@@ -195,14 +195,14 @@
 
 		assert (flags & F_DISCARDED) == 0 : "attempt to write discarded node";
 
-		writer.put((byte) 0);  // will be overwritten later
+		writer.put1u(0);  // will be overwritten later
 		flags |= (nodeClass & MAX_DEST_CLASS_MASK); // max. road class of any outgoing road
-		writer.put((byte) flags);
+		writer.put1u(flags);
 
 		if (haveLargeOffsets()) {
-			writer.putInt((latOff << 16) | (lonOff & 0xffff));
+			writer.put4((latOff << 16) | (lonOff & 0xffff));
 		} else {
-			writer.put3((latOff << 12) | (lonOff & 0xfff));
+			writer.put3s((latOff << 12) | (lonOff & 0xfff));
 		}
 
 		if (!arcs.isEmpty()) {
@@ -253,9 +253,9 @@
 	public void writeNod3OrNod4(ImgFileWriter writer) {
 		assert isBoundary() : "trying to write nod3 for non-boundary node";
 
-		writer.put3(coord.getLongitude());
-		writer.put3(coord.getLatitude()); 
-		writer.put3(offsetNod1);
+		writer.put3s(coord.getLongitude());
+		writer.put3s(coord.getLatitude()); 
+		writer.put3u(offsetNod1);
 	}
 
 	public void discard() {
@@ -294,7 +294,7 @@
 	private void setLatOff(int latOff) {
 		if(log.isDebugEnabled())
 			log.debug("lat off", Integer.toHexString(latOff));
-		this.latOff = (char) latOff;
+		this.latOff = latOff;
 		checkOffSize(latOff);
 	}
 
@@ -301,7 +301,7 @@
 	private void setLonOff(int lonOff) {
 		if(log.isDebugEnabled())
 			log.debug("long off", Integer.toHexString(lonOff));
-		this.lonOff = (char) lonOff;
+		this.lonOff = lonOff;
 		checkOffSize(lonOff);
 	}
 
Index: src/uk/me/parabola/imgfmt/app/net/RouteRestriction.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/RouteRestriction.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/RouteRestriction.java	(working copy)
@@ -53,7 +53,7 @@
 
 	private final RouteNode viaNode; 
 	// offset in Table C
-	private byte offsetSize;
+	private int offsetSize;
 	private int offsetC;
 
 	// last restriction in a node
@@ -147,13 +147,13 @@
 	 * 
 	 */
 	public void write(ImgFileWriter writer, int tableOffset) {
-		writer.put(RESTRICTION_TYPE); 
+		writer.put1u(RESTRICTION_TYPE);
 
 		writer.put(flags);
-		writer.put((byte)0); // meaning ?
+		writer.put1u(0); // meaning ?
 
 		if(exceptMask != 0)
-			writer.put(exceptMask);
+			writer.put1u(exceptMask);
 
 		int numArcs = arcs.size();
 		int[] offsets = new int[numArcs+1];
@@ -180,10 +180,10 @@
 		}
 
 		for (int offset : offsets)
-			writer.putChar((char) offset);
+			writer.put2u(offset);
 
 		for (RouteArc arc: arcs)
-			writer.put(arc.getIndexA());
+			writer.put1u(arc.getIndexA());
 	}
 
 	/**
@@ -196,12 +196,12 @@
 			assert offset < 0x80;
 			if (last)
 				offset |= 0x80;
-			writer.put((byte) offset);
+			writer.put1u(offset);
 		} else {
 			assert offset < 0x8000;
 			if (last)
 				offset |= 0x8000;
-			writer.putChar((char) offset);
+			writer.put2u(offset);
 		}
 	}
 
@@ -224,7 +224,7 @@
 		return offsetC;
 	}
 
-	public void setOffsetSize(byte size) {
+	public void setOffsetSize(int size) {
 		offsetSize = size;
 	}
 
Index: src/uk/me/parabola/imgfmt/app/net/TableA.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/TableA.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/TableA.java	(working copy)
@@ -100,7 +100,7 @@
 	 * Retrieve an arc's index.
 	 * Order in table A: roundabouts, unpaved, ferry, paved 
 	 */
-	public byte getIndex(RouteArc arc) {
+	public int getIndex(RouteArc arc) {
 		frozen = true;			// don't allow any more arcs to be added
 		int i;
 		RoadDef rd = arc.getRoadDef();
@@ -125,7 +125,7 @@
 			i = roundaboutArcs.size() + unpavedArcs.get(rd);
 		}
 		assert i < 0x100 : "Table A index too large: " + rd;
-		return (byte) i;
+		return i;
 	}
 
 	/**
@@ -159,9 +159,9 @@
 	 * be fit for writing, so at this point we check
 	 * it isn't too large.
 	 */
-	public byte getNumberOfItems() {
+	public int getNumberOfItems() {
 		assert size() < 0x100 : "Table A too large";
-		return (byte)size();
+		return size();
 	}
 
 	/**
@@ -174,7 +174,7 @@
 		log.debug("tab a offset", offset, "tab a size", size);
 	
 		for (int i = 0; i < size; i++)
-			writer.put((byte) 0);
+			writer.put1u(0);
 	}
 
 	/**
@@ -208,8 +208,8 @@
 		final int ACCESS_TOP_BITS = 0xc000;
 		pos |= (access & ACCESS_TOP_BITS) << 8;
 		access &= ~ACCESS_TOP_BITS;
-		writer.put3(pos);
-		writer.put((byte) rd.getTabAInfo());
-		writer.put((byte) access);
+		writer.put3u(pos);
+		writer.put1u(rd.getTabAInfo());
+		writer.put1u(access);
 	}
 }
Index: src/uk/me/parabola/imgfmt/app/net/TableB.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/TableB.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/TableB.java	(working copy)
@@ -50,9 +50,9 @@
          * be fit for writing, so at this point we check
          * it isn't too large.
          */
-	public byte getNumberOfItems() {
+	public int getNumberOfItems() {
 		assert nodes.size() < 0x100 : "Table B too large.";
-		return (byte) nodes.size();
+		return nodes.size();
 	}
 
 	/**
@@ -72,11 +72,11 @@
 	/**
 	 * Retrieve a nodes index. Checked for correct bounds.
 	 */
-	public byte getIndex(RouteNode node) {
+	public int getIndex(RouteNode node) {
 		int i = nodes.indexOf(node);
 		assert i >= 0 : "Trying to read Table B index for non-registered node.";
 		assert i < 0x100 : "Table B index too large.";
-		return (byte) i;
+		return i;
 	}
 
 	/**
@@ -87,7 +87,7 @@
 		offset = writer.position();
 		int size = nodes.size() * ITEM_SIZE;
 		for (int i = 0; i < size; i++)
-			writer.put((byte) 0);
+			writer.put1u(0);
 	}
 
 	/**
@@ -96,6 +96,6 @@
 	public void writePost(ImgFileWriter writer) {
 		writer.position(offset);
 		for (RouteNode node : nodes)
-			writer.put3(node.getOffsetNod1());
+			writer.put3u(node.getOffsetNod1());
 	}
 }
Index: src/uk/me/parabola/imgfmt/app/net/TableC.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/TableC.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/TableC.java	(working copy)
@@ -43,18 +43,18 @@
 	public void write(ImgFileWriter writer, int tablesOffset) {
 		if (!restrictions.isEmpty()) {
 			if (size < 0x100)
-				writer.put((byte) size);
+				writer.put1u(size);
 			else
-				writer.putChar((char) size);
+				writer.put2u(size);
 			for (RouteRestriction restr : restrictions)
 				restr.write(writer, tablesOffset);
 		}
 		if(tabA.numRoundaboutArcs() > 0)
-			writer.put((byte)tabA.numRoundaboutArcs());
+			writer.put1u(tabA.numRoundaboutArcs());
 		if(tabA.numUnpavedArcs() > 0)
-			writer.put((byte)tabA.numUnpavedArcs());
+			writer.put1u(tabA.numUnpavedArcs());
 		if(tabA.numFerryArcs() > 0)
-			writer.put((byte)tabA.numFerryArcs());
+			writer.put1u(tabA.numFerryArcs());
 	}
 
 	/**
@@ -74,7 +74,7 @@
 	/**
 	 * The size of restriction indices in the nodes area.
 	 */
-	private byte getOffsetSize() {
+	private int getOffsetSize() {
 		if (size < 0x80)
 			return 1; // allows 7 bit index (8th bit is flag)
 		else if (size < 0x8000)
@@ -85,12 +85,12 @@
 	}
 
 	public void propagateSizeBytes() {
-		byte b = getOffsetSize();
+		int b = getOffsetSize();
 		for (RouteRestriction restr : restrictions)
 			restr.setOffsetSize(b);
 	}
 
-	public byte getFormat() {
+	public int getFormat() {
 		// Table C format bitmask
 		// 0x01 = 1-255 bytes of restrictions
 		// 0x02 = 256-65535 bytes of restrictions
@@ -108,6 +108,6 @@
 			format |= 0x08;
 		if(tabA.numFerryArcs() > 0)
 			format |= 0x10;
-		return (byte)format;
+		return format;
 	}
 }
Index: src/uk/me/parabola/imgfmt/app/srt/SRTFile.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/srt/SRTFile.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/srt/SRTFile.java	(working copy)
@@ -84,7 +84,7 @@
 	private void writeDescription(ImgFileWriter writer) {
 		writer.position(header.getHeaderLength() + SRTHeader.HEADER2_LEN);
 		writer.put(description.getBytes(Charset.forName("ascii")));
-		writer.put((byte) 0);
+		writer.put1u( 0);
 		header.endDescription(writer.position());
 	}
 
@@ -95,7 +95,7 @@
 	 */
 	private void writeSrt4Chars(ImgFileWriter writer) {
 		for (int i = 1; i < 256; i++) {
-			writer.put(sort.getFlags(i));
+			writer.put1u(sort.getFlags(i));
 			writeWeights(writer, i);
 		}
 		header.endCharTable(writer.position());
@@ -109,15 +109,15 @@
 			assert primary <= 0xffff;
 			assert secondary <= 0xff;
 			assert tertiary <= 0xff;
-			writer.putChar((char) primary);
-			writer.put((byte) secondary);
-			writer.put((byte) tertiary);
+			writer.put2u(primary);
+			writer.put1u(secondary);
+			writer.put1u(tertiary);
 		} else {
 			assert primary <= 0xff;
 			assert secondary <= 0xf;
 			assert tertiary <= 0xf;
-			writer.put((byte) primary);
-			writer.put((byte) ((tertiary << 4) | (secondary & 0xf)));
+			writer.put1u(primary);
+			writer.put1u((tertiary << 4) | (secondary & 0xf));
 		}
 	}
 
@@ -133,12 +133,12 @@
 		for (int j = 1; j <= size; j++) {
 			CodePosition b = sort.getExpansion(j);
 			if (isMulti) {
-				writer.putChar(b.getPrimary());
-				writer.put(b.getSecondary());
-				writer.put(b.getTertiary());
+				writer.put2u(b.getPrimary());
+				writer.put1u(b.getSecondary());
+				writer.put1u(b.getTertiary());
 			} else {
-				writer.put((byte) b.getPrimary());
-				writer.put((byte) ((b.getTertiary() << 4) | (b.getSecondary() & 0xf)));
+				writer.put1u(b.getPrimary());
+				writer.put1u((b.getTertiary() << 4) | (b.getSecondary() & 0xf));
 			}
 		}
 
@@ -148,7 +148,7 @@
 	private void writeSrt7(SectionWriter writer) {
 		assert sort.isMulti();
 		for (int i = 1; i <= sort.getMaxPage(); i++) {
-			writer.putInt(srt8Starts.get(i));
+			writer.put4(srt8Starts.get(i));
 		}
 		header.endSrt7(writer.position());
 	}
@@ -162,7 +162,7 @@
 				srt8Starts.set(p, offset);
 				for (int j = 0; j < 256; j++) {
 					int ch = p * 256 + j;
-					writer.put(sort.getFlags(ch));
+					writer.put1u(sort.getFlags(ch));
 					writeWeights(writer, ch);
 					offset += 5;
 				}
Index: src/uk/me/parabola/imgfmt/app/srt/SRTHeader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/srt/SRTHeader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/srt/SRTHeader.java	(working copy)
@@ -60,9 +60,9 @@
 	}
 
 	protected void readFileHeader(ImgFileReader reader) throws ReadFailedException {
-		reader.getChar(); // expected: 1
-		header2.setPosition(reader.getInt());
-		header2.setSize(reader.getChar());
+		reader.get2u(); // expected: 1
+		header2.setPosition(reader.get4());
+		header2.setSize(reader.get2u());
 	}
 
 	/**
@@ -71,18 +71,18 @@
 	 */
 	protected void writeFileHeader(ImgFileWriter writer) {
 		if (getHeaderLength() <= 29) {
-			writer.putChar((char) 1);
+			writer.put2u(1);
 
-			writer.putInt(header2.getPosition());
-			writer.putChar((char) header2.getSize());
+			writer.put4(header2.getPosition());
+			writer.put2u(header2.getSize());
 		} else {
 			// this appears in unicode maps dated 2016 and 2017
-			writer.putChar((char) 0);
-			writer.putInt(header2.getPosition());
-			writer.putChar((char) header2.getSize());
-			writer.putChar((char) 1);
-			writer.putInt(header2.getPosition());
-			writer.putChar((char) header2.getSize());
+			writer.put2u(0);
+			writer.put4(header2.getPosition());
+			writer.put2u(header2.getSize());
+			writer.put2u(1);
+			writer.put4(header2.getPosition());
+			writer.put2u(header2.getSize());
 			
 			// older maps contain this variant (note the different order)
 //			writer.putChar((char) 1);
@@ -122,40 +122,40 @@
 	 */
 	protected void writeHeader3(ImgFileWriter writer) {
 		if (sort.isMulti()) {
-			writer.putChar((char) HEADER3_MULTI_LEN);
+			writer.put2u(HEADER3_MULTI_LEN);
 		} else {
-			writer.putChar((char) HEADER3_LEN);
+			writer.put2u(HEADER3_LEN);
 		}
 
-		writer.putChar((char) sort.getId1());
-		writer.putChar((char) sort.getId2());
-		writer.putChar((char) sort.getCodepage());
+		writer.put2u(sort.getId1());
+		writer.put2u(sort.getId2());
+		writer.put2u(sort.getCodepage());
 		if (sort.isMulti())
-			writer.putInt(0x6f02);
+			writer.put4(0x6f02);
 		else
-			writer.putInt(0x2002);
+			writer.put4(0x2002);
 
 		chartab.writeSectionInfo(writer, true, true);
-		writer.putChar((char) 0);
+		writer.put2u(0);
 
 		expansions.writeSectionInfo(writer, true, true);
-		writer.putChar((char) 0);
+		writer.put2u(0);
 
 		// SRT6 A repeat pointer to the single byte character table
-		writer.putInt(chartab.getPosition());
-		writer.putInt(0);
+		writer.put4(chartab.getPosition());
+		writer.put4(0);
 
 		if (sort.isMulti()) {
-			writer.putInt(1);
-			writer.putInt(sort.getMaxPage());  // max block in srt7
+			writer.put4(1);
+			writer.put4(sort.getMaxPage());  // max block in srt7
 
 			srt7.writeSectionInfo(writer, true);
-			writer.putChar((char) 0);
-			writer.putInt(0);
+			writer.put2u(0);
+			writer.put4(0);
 			srt8.writeSectionInfo(writer, true);
 
-			writer.putChar((char) 0);
-			writer.putInt(0);
+			writer.put2u(0);
+			writer.put4(0);
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/srt/SrtFileReader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/srt/SrtFileReader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/srt/SrtFileReader.java	(working copy)
@@ -71,14 +71,14 @@
 	private void readTableHeader() {
 		ImgFileReader reader = getReader();
 		reader.position(tableHeader.getPosition());
-		int len = reader.getChar();
+		int len = reader.get2u();
 		sort.setHeader3Len(len);
-		sort.setId1(reader.getChar());
-		sort.setId2(reader.getChar());
-		sort.setCodepage(reader.getChar());
+		sort.setId1(reader.get2u());
+		sort.setId2(reader.get2u());
+		sort.setCodepage(reader.get2u());
 		if (sort.getCodepage() == 65001)
 			sort.setMulti(true);
-		reader.getInt(); //?
+		reader.get4(); //?
 		characterTable.readSectionInfo(reader, true);
 		reader.position(reader.position() + 6); // padding?
 		srt5.readSectionInfo(reader, true);
@@ -87,8 +87,8 @@
 			srt6.readSectionInfo(reader, false);
 		}
 		if (len > 0x34) {
-			reader.getInt();
-			int maxCodeBlock = reader.getInt();
+			reader.get4();
+			int maxCodeBlock = reader.get4();
 			sort.setMaxPage(maxCodeBlock);
 			srt7.readSectionInfo(reader, true);
 			reader.position(reader.position() + 6); // padding?
@@ -110,7 +110,7 @@
 
 		int block = 1;
 		for (int i = 0; i < srt7.getNumItems(); i++) {
-			int val = reader.getInt();
+			int val = reader.get4();
 			if (val >= 0)
 				offsetToBlock.put(val/srt8.getItemSize(), block);
 			block++;
@@ -127,7 +127,7 @@
 			Integer nblock = offsetToBlock.get(i);
 			if (nblock != null) 
 				block = nblock;
-			int flags = reader.get() & 0xff;
+			int flags = reader.get1u();
 			CodePosition cp = readCharPosition(reclen-1);
 			int ch = block*256 + (i % 256);
 			
@@ -149,7 +149,7 @@
 		long start = tableHeader.getPosition() + characterTable.getPosition();
 		reader.position(start);
 		for (int ch = 1; ch <= characterTable.getNumItems(); ch++) {
-			int flags = reader.get() & 0xff;
+			int flags = reader.get1u();
 			CodePosition cp = readCharPosition(rs-1);
 			if ((flags & 0xf0) != 0) { 
 				sort.add(ch, countExp + 1, 0, 0, flags);
@@ -172,18 +172,18 @@
 		CodePosition cp = new CodePosition();
 		int rec;
 		if (posLength == 2) {
-			rec = reader.getChar();
+			rec = reader.get2u();
 			cp.setPrimary((char) (rec & 0xff));
 			cp.setSecondary((byte) ((rec >> 8) & 0xf));
 			cp.setTertiary((byte) ((rec >> 12) & 0xf));
 			
 		} else if (posLength == 3) {
-			rec = reader.get3();
+			rec = reader.get3u();
 			cp.setPrimary((char) (rec & 0xff));
 			cp.setSecondary((byte) ((rec >> 8) & 0xf));
 			cp.setTertiary((byte) ((rec >> 12) & 0xf));
 		} else if (posLength == 4) {
-			rec = reader.getInt();
+			rec = reader.get4();
 			cp.setPrimary((char) (rec & 0xffff));
 			cp.setSecondary((byte) ((rec >> 16) & 0xff));
 			cp.setTertiary((byte) ((rec >> 24) & 0xff));
Index: src/uk/me/parabola/imgfmt/app/trergn/Overview.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/Overview.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/Overview.java	(working copy)
@@ -33,9 +33,9 @@
 	public static final int SHAPE_KIND = 3;
 
 	private final int kind; // The kind of overview; point, line etc.
-	private final char extType;
-	private final char type;
-	private final char subType;
+	private final int extType;
+	private final int type;
+	private final int subType;
 	private final int minResolution;
 	private final int size;
 
@@ -44,9 +44,9 @@
 	protected Overview(int kind, int fullType, int minres) {
 		this.kind = kind;
 
-		this.extType = (char)((fullType >> 16) & 0xff);
-		this.type = (char) (fullType >> 8 & 0xff);
-		this.subType = (char) (fullType & 0xff);
+		this.extType =  fullType >> 16;
+		this.type =    (fullType >> 8) & 0xff;
+		this.subType =  fullType       & 0xff;
 		this.minResolution = minres;
 
 		if (kind == POINT_KIND)
@@ -57,15 +57,15 @@
 
 	public void write(ImgFileWriter file) {
 		if (extType == 0) {
-			file.put((byte) (type & 0xff));
-			file.put((byte) maxLevel);
+			file.put1u(type);
+			file.put1u(maxLevel);
 			if (size > 2)
-				file.put((byte) (subType & 0xff));
+				file.put1u(subType);
 		} else {
-			file.put((byte) type);
-			file.put((byte) maxLevel);
-			file.put((byte) subType);
-			file.put((byte) 0);
+			file.put1u(type);
+			file.put1u(maxLevel);
+			file.put1u(subType);
+			file.put1u(0);
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/trergn/Point.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/Point.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/Point.java	(working copy)
@@ -49,16 +49,16 @@
 	public void write(ImgFileWriter file) {
 		boolean hasSubtype = false;
 		int type = getType();
-		byte subtype = 0;
+		int subtype = 0;
 		if (type > 0xff) {
 			if((type & 0xff) != 0) {
 			    hasSubtype = true;
-			    subtype = (byte) type;
+			    subtype = type & 0xff;
 			}
 			type >>= 8;
 		}
 
-		file.put((byte) type);
+		file.put1u(type);
 
 		int off = getLabel().getOffset();
 		if (poi != null) {
@@ -68,11 +68,11 @@
 		if (hasSubtype)
 			off |= 0x800000;
 
-		file.put3(off);
-		file.putChar((char) getDeltaLong());
-		file.putChar((char) getDeltaLat());
+		file.put3u(off);
+		file.put2s(getDeltaLong());
+		file.put2s(getDeltaLat());
 		if (hasSubtype)
-			file.put(subtype);
+			file.put1u(subtype);
 	}
 
 	/*
Index: src/uk/me/parabola/imgfmt/app/trergn/Polyline.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/Polyline.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/Polyline.java	(working copy)
@@ -101,7 +101,7 @@
 		}
 
 		// The type of feature, also contains a couple of flags hidden inside.
-		byte b1 = (byte) getType();
+		int b1 = getType();
 		if (direction)
 			b1 |= FLAG_DIR;  // Polylines only.
 
@@ -111,7 +111,7 @@
 		if (blen >= 0x100)
 			b1 |= FLAG_2BYTE_LEN;
 
-		file.put(b1);
+		file.put1u(b1);
 
 		// The label, contains a couple of flags within it.
 		int loff = getLabel().getOffset();
@@ -130,19 +130,16 @@
 					roaddef.addLabel(rl);
 		}
 
-		file.put3(loff);
+		file.put3u(loff);
 
 		// The delta of the longitude from the subdivision centre point
 		// note that this has already been calculated.
-		file.putChar((char) getDeltaLong());
-		file.putChar((char) getDeltaLat());
+		file.put2s(getDeltaLong());
+		file.put2s(getDeltaLat());
 		if(log.isDebugEnabled())
 			log.debug("out center", getDeltaLat(), getDeltaLong());
 
-		if (blen < 0x100)
-			file.put((byte) (blen & 0xff));
-		else
-			file.putChar((char) (blen & 0xffff));
+		file.putNu(blen < 0x100 ? 1 : 2, blen);
 
 		file.put(bw.getBytes(), 0, blen+1);
 	}
Index: src/uk/me/parabola/imgfmt/app/trergn/RGNFile.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/RGNFile.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/RGNFile.java	(working copy)
@@ -149,7 +149,7 @@
 			if (off > 0xffff)
 				throw new IllegalStateException("IndPoint offset too large: " + off);
 
-			getWriter().putChar((char) off);
+			getWriter().put2u((int) off);
 			position(currPos);
 		}
 	}
@@ -164,7 +164,7 @@
 
 			if (log.isDebugEnabled())
 				log.debug("setting polyline offset to", off);
-			getWriter().putChar((char) off);
+			getWriter().put2u((int) off);
 
 			position(currPos);
 		}
@@ -181,7 +181,7 @@
 			if (log.isDebugEnabled())
 				log.debug("setting polygon offset to ", off, " @", polygonPtrOff);
 			position(polygonPtrOff);
-			getWriter().putChar((char) off);
+			getWriter().put2u((int) off);
 			position(currPos);
 		}
 	}
@@ -203,8 +203,8 @@
 	}
 
 	public boolean haveExtendedTypes() {
-		return (extTypePointsData != null ||
+		return extTypePointsData != null ||
 				extTypeLinesData != null ||
-				extTypeAreasData != null);
+				extTypeAreasData != null;
 	}
 }
Index: src/uk/me/parabola/imgfmt/app/trergn/RGNFileReader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/RGNFileReader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/RGNFileReader.java	(working copy)
@@ -100,8 +100,8 @@
 		while (position() < end) {
 			Point p = new Point(sd);
 
-			byte t = reader.get();
-			int val = reader.getu3();
+			int t = reader.get1u();
+			int val = reader.get3u();
 			boolean hasSubtype = false;
 			if ((val & 0x800000) != 0)
 				hasSubtype = true;
@@ -124,15 +124,15 @@
 			}
 			p.setLabel(l);
 
-			p.setDeltaLong((short)reader.getChar());
-			p.setDeltaLat((short)reader.getChar());
+			p.setDeltaLong(reader.get2s());
+			p.setDeltaLat(reader.get2s());
 
 			if (hasSubtype) {
-				byte st = reader.get();
-				p.setType(((t & 0xff) << 8) | (st & 0xff));
+				int st = reader.get1u();
+				p.setType((t << 8) | st);
 				//p.setHasSubtype(true);
 			} else {
-				p.setType(t & 0xff);
+				p.setType(t);
 			}
 
 			p.setNumber(number++);
@@ -151,15 +151,15 @@
 		while (position() < end) {
 			Point p = new Point(sd);
 
-			int type = reader.get() << 8;
+			int type = reader.get1u() << 8;
 			byte b = reader.get();
 			type |= 0x10000  +  (b & 0x1f);
 			p.setType(type);
-			p.setDeltaLong((short)reader.getChar());
-			p.setDeltaLat((short)reader.getChar());
+			p.setDeltaLong(reader.get2s());
+			p.setDeltaLat(reader.get2s());
 			Label l;
 			if ((b & 0x20) != 0 ){
-				int labelOffset = reader.getu3();
+				int labelOffset = reader.get3u();
 				boolean hasPoi = (labelOffset & 0x400000) != 0;
 				if (hasPoi) {
 					POIRecord record = lblFile.fetchPoi(labelOffset);
@@ -269,7 +269,7 @@
 			line.setType(type & 0x3f);
 			line.setDirection((type & 0x40) != 0);
 		}
-		int labelOffset = reader.getu3();
+		int labelOffset = reader.get3u();
 		// Extra bit (for bit stream)
 		boolean extra = (labelOffset & 0x400000) != 0;
 		Label label;
@@ -285,13 +285,13 @@
 		line.setLabel(label);
 
 
-		line.setDeltaLong((short)reader.getChar());
-		line.setDeltaLat((short)reader.getChar());
+		line.setDeltaLong(reader.get2s());
+		line.setDeltaLat(reader.get2s());
 		int len;
 		if ((type & 0x80) == 0)
-			len = reader.get() & 0xff;
+			len = reader.get1u();
 		else
-			len = reader.getChar();
+			len = reader.get2u();
 
 		int base = reader.get();
 
@@ -309,15 +309,15 @@
 	 * @param line The line or shape that is to be populated.
 	 */
 	private void readLineCommonExtType(ImgFileReader reader, Subdivision div, Polyline line) {
-		int type = reader.get();
-		type = (type & 0xff) << 8;
-		byte b1 = reader.get();
+		int type = reader.get1u();
+		type <<= 8;
+		int b1 = reader.get1u();
 		boolean hasExtraBytes = (b1 & 0x80) != 0;
 		boolean hasLabel = (b1 & 0x20) != 0;
 		type |= 0x10000  + (b1 & 0x1f);
 		line.setType(type);
-		line.setDeltaLong((short)reader.getChar());
-		line.setDeltaLat((short)reader.getChar());
+		line.setDeltaLong(reader.get2s());
+		line.setDeltaLat(reader.get2s());
 		b1 = reader.get();
 		int len;
 		// one byte or two byte length field?
@@ -326,13 +326,13 @@
 			assert len < 0x7f;
 		}
 		else {
-			byte b2 = reader.get();
-			len = (((b2 & 0xff) << 8) + (b1 & 0xff)) >> 2;
+			int b2 = reader.get1u();
+			len = ((b2 << 8) + b1) >> 2;
 			assert len >= 0x7f;
 		}
 		--len; // the encoded value includes the base field 
 		assert len > 0;
-		int base = reader.get();
+		int base = reader.get1u();
 		byte[] bitstream = reader.get(len);
 		BitReader br = new BitReader(bitstream);
 	
@@ -340,7 +340,7 @@
 		readBitStream(br, div, line, false, len, base);
 	
 		if (hasLabel){
-			int labelOffset = reader.getu3();
+			int labelOffset = reader.get3u();
 			Label label;			
 			if ((labelOffset & 0x800000) == 0) {
 				label = lblFile.fetchLabel(labelOffset & 0x7fffff);
@@ -546,17 +546,17 @@
 			pointOffset = 0;
 
 			if (sd.needsIndPointPtr()) {
-				indPointOffset = reader.getChar();
+				indPointOffset = reader.get2u();
 				headerLen += 2;
 			}
 			
 			if (sd.needsPolylinePtr()) {
-				lineOffset = reader.getChar();
+				lineOffset = reader.get2u();
 				headerLen += 2;
 			}
 
 			if (sd.needsPolygonPtr()) {
-				polygonOffset = reader.getChar();
+				polygonOffset = reader.get2u();
 				headerLen += 2;
 			}
 
Index: src/uk/me/parabola/imgfmt/app/trergn/RGNHeader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/RGNHeader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/RGNHeader.java	(working copy)
@@ -57,27 +57,27 @@
 		data.readSectionInfo(reader, false);
 
 		if (getHeaderLength() > 29){
-			extTypeAreasOffset = reader.getInt();
-			extTypeAreasSize = reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			extTypeLinesOffset = reader.getInt();
-			extTypeLinesSize = reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			extTypePointsOffset = reader.getInt();
-			extTypePointsSize = reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			reader.getInt();
-			reader.getInt();
+			extTypeAreasOffset = reader.get4();
+			extTypeAreasSize = reader.get4();
+			reader.get4();
+			reader.get4();
+			reader.get4();
+			reader.get4();
+			reader.get4();
+			extTypeLinesOffset = reader.get4();
+			extTypeLinesSize = reader.get4();
+			reader.get4();
+			reader.get4();
+			reader.get4();
+			reader.get4();
+			reader.get4();
+			extTypePointsOffset = reader.get4();
+			extTypePointsSize = reader.get4();
+			reader.get4();
+			reader.get4();
+			reader.get4();
+			reader.get4();
+			reader.get4();
 		}
 	}
 
@@ -91,32 +91,32 @@
 		data.writeSectionInfo(writer, false);
 
 		if (getHeaderLength() > 29) {
-			writer.putInt(extTypeAreasOffset);
-			writer.putInt(extTypeAreasSize);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
+			writer.put4(extTypeAreasOffset);
+			writer.put4(extTypeAreasSize);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
 
-			writer.putInt(extTypeLinesOffset);
-			writer.putInt(extTypeLinesSize);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
+			writer.put4(extTypeLinesOffset);
+			writer.put4(extTypeLinesSize);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
 
-			writer.putInt(extTypePointsOffset);
-			writer.putInt(extTypePointsSize);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
+			writer.put4(extTypePointsOffset);
+			writer.put4(extTypePointsSize);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
 		}
 	}
 
@@ -165,4 +165,4 @@
 	public int getExtTypePointsSize() {
 		return extTypePointsSize;
 	}
-}
\ No newline at end of file
+}
